---
title: IDBKeyRange.bound()
slug: Web/API/IDBKeyRange/bound
tags:
  - API
  - Database
  - IDBKeyRange
  - IndexedDB
  - Method
  - Reference
  - Storage
  - bound
---
<p>{{ APIRef("IndexedDB") }}</p>

<div>
<p>The <strong><code>bound()</code></strong> method of the {{domxref("IDBKeyRange")}} interface creates a new key range with the specified upper and lower bounds. The bounds can be open (that is, the bounds exclude the endpoint values) or closed (that is, the bounds include the endpoint values). By default, the bounds are closed.</p>
</div>

<p>{{AvailableInWorkers}}</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox" style="font-size: 14px;">var <em>myIDBKeyRange</em> = <em>IDBKeyRange</em>.bound(<em>lower</em>, <em>upper</em>);
var <em>myIDBKeyRange</em> = <em>IDBKeyRange</em>.bound(<em>lower</em>, <em>upper</em>, <em>lowerOpen</em>);
var <em>myIDBKeyRange</em> = <em>IDBKeyRange</em>.bound(<em>lower</em>, <em>upper</em>, <em>lowerOpen</em>, <em>upperOpen</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>lower </dt>
 <dd>specifies the lower bound of the new key range. </dd>
 <dt>upper </dt>
 <dd>specifies the upper bound of the new key range.</dd>
 <dt>lowerOpen {{optional_inline}}</dt>
 <dd>indicates whether the lower bound excludes the endpoint value. The default is false. </dd>
 <dt>upperOpen {{optional_inline}}</dt>
 <dd>Indicates whether the upper bound excludes the endpoint value. The default is false. </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>{{domxref("IDBKeyRange")}}: The newly created key range.</p>

<h3 id="Exceptions"><span style="line-height: 1.5;">Exceptions</span></h3>

<p><span style="line-height: 1.5;">This method may raise a {{domxref("DOMException")}} of the following type:</span></p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Exception</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><font face="Courier New, Andale Mono, monospace"><span style="line-height: normal;">DataError</span></font></td>
   <td>
    <p>The following conditions raise an exception:</p>

    <ul>
     <li>The lower or upper parameters were not passed a valid key.</li>
     <li>The lower key is greater than the upper key.</li>
     <li>The lower key and upper key match and either of the bounds are open.</li>
    </ul>
   </td>
  </tr>
 </tbody>
</table>

<h2 id="Example">Example</h2>

<p>The following example illustrates how you'd use a bound key range. Here we declare a <code>keyRangeValue = IDBKeyRange.bound("A", "F");</code> — a range between values of "A" and "F". We open a transaction (using {{domxref("IDBTransaction")}}) and an object store, and open a Cursor with {{domxref("IDBObjectStore.openCursor")}}, declaring <code>keyRangeValue</code> as its optional key range value. This means that the cursor will only retrieve records with keys inside that range. This range includes the values "A" and "F", as we haven't declared that they should be open  bounds. If we used <span style="background-color: #fafbfc; font-family: consolas,monaco,andale mono,monospace; font-size: 1rem; line-height: 19px; white-space: pre;">IDBKeyRange.bound("A", "F", true, true);</span>, then the range would not include "A" and "F", only the values between them.</p>

<div class="note">
<p><strong>Note</strong>: For a more complete example allowing you to experiment with key range, have a look at the idbkeyrange directory <a href="https://github.com/mdn/indexeddb-examples/tree/master/idbkeyrange">in the indexeddb-examples</a> repo (<a href="https://mdn.github.io/indexeddb-examples/idbkeyrange/">view the example live too</a>.)</p>
</div>

<pre class="brush: js" style="font-size: 14px;">function displayData() {
  var keyRangeValue = IDBKeyRange.bound("A", "F");

  var transaction = db.transaction(['fThings'], 'readonly');
  var objectStore = transaction.objectStore('fThings');

  objectStore.openCursor(keyRangeValue).onsuccess = function(event) {
    var cursor = event.target.result;
      if(cursor) {
        var listItem = document.createElement('li');
        listItem.innerHTML = '&lt;strong&gt;' + cursor.value.fThing + '&lt;/strong&gt;, ' + cursor.value.fRating;
        list.appendChild(listItem);

        cursor.continue();
      } else {
        console.log('Entries all displayed.');
      }
    };
  };</pre>

<h2 id="Specifications">Specifications</h2>

<div>
<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('IndexedDB', '#dom-idbkeyrange-bound', 'bound()')}}</td>
   <td>{{Spec2('IndexedDB')}}</td>
   <td> </td>
  </tr>
  <tr>
   <td>{{SpecName("IndexedDB 2", "#dom-idbkeyrange-bound", "bound()")}}</td>
   <td>{{Spec2("IndexedDB 2")}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>
</div>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.IDBKeyRange.bound")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB">Using IndexedDB</a></li>
 <li>Starting transactions: {{domxref("IDBDatabase")}}</li>
 <li>Using transactions: {{domxref("IDBTransaction")}}</li>
 <li>Setting a range of keys: {{domxref("IDBKeyRange")}}</li>
 <li>Retrieving and making changes to your data: {{domxref("IDBObjectStore")}}</li>
 <li>Using cursors: {{domxref("IDBCursor")}}</li>
 <li>Reference example: <a class="external" href="https://github.com/mdn/to-do-notifications/tree/gh-pages">To-do Notifications</a> (<a class="external" href="https://mdn.github.io/to-do-notifications/">view example live</a>.)</li>
</ul>
